﻿/******************************************************************************
Author: Brian Roller
Filename: script.js
Date: 4/09/06
******************************************************************************/

var isOpen; // used for animation flag
var userXML; // used often; improves performance
var partnerXML; // used oftne; improves performance
var moodsArray; // used for popup menu
var testing; // flag for testing mode
var processRotation; // process animation

var uploadServerTmp; // used for checking server change
var downloadServerTmp; // used for checking server change
var uploadUsernameTmp; // used for checking  preferences.userName.value change
var uploadPasswordTmp; // used for checking  password change
var downloadUsernameTmp; // used for checking  preferences.userName.value change
var downloadPasswordTmp; // used for checking  password change
var usernameTmp; // used for checking preferences.userName.value change
var partnernameTmp; // used for checking partner name change
var userMoodFileLocationTmp; // used for checking the partner's file locaiton change
var partnerMoodFileLocationTmp; // used for checking the partner's file location

var textAreas;// Used for dynamic creation of textAreas for Mood Manager
var moodsFrame;// Used to house textAreas
var scroll; // Used to scroll moods in moodManager
var hasFocus; // Signals which row has focus

var sliders = new Array(); // For sliders
var oldHeartC; // for color changer
var oldWingC; // for color changer
var selectedT;
var oldX;
var oldY;
var oldMoodName;
var newMoodName;

/**
Reads preferences, initializes widget to last moods used, 
switches to proper testing mode, and creates the mood
popup menu.
**/
function setup() {
  // Check to see if this is the first time the widget is being run
  isFirstTime();
  
  //Initialize
  Upper_Name.data = preferences.partnerName.value;
  Lower_Name.data = preferences.userName.value;  
  Timer.interval = preferences.timerInterval.value; 

  // Set testing preference
  testing = (preferences.testing.value == "true");
  switchTesting(testing);

  // Update components
  if(!testing) {
    putMood();
    testDownloadFile();
    readUserXML();
    readPartnerXML();
    Timer.ticking = true;
  } else {
    testing = false;
    readUserXML();
    readPartnerXML();
    testing = true;    
  }
  
  // Make widget visible
  mainWindow.visible = 1;  
}

/**
Determine if this is the first time the widget has been run.
If it is the first time, display welcome message.
**/
function isFirstTime() {
  var result;

  // Check for flag file
  if(preferences.firstTime.value == "true") {
    preferences.firstTime.value = "false";
    alert(filesystem.readFile("firstTime"));
    
    // test default download settings
    result = testDownloadServer();
    if(result) {
      alert("WARNING: The default Download Server is no longer working!"
          + "\n\nYou must enter your own server information or the widget will not work properly!");
    }
    
    // test default upload settings
    result = testUploadServer();
    if(result) {
      alert("WARNING: The default Upload Server is no longer working!"
          + "\n\nYou must enter your own server information or the widget will not work properly!");
    }    
    
    // Show preferences window
    showWidgetPreferences();
    
    // Check to see if names were changed
    if(preferences.userName.value == "NotSet") {
      alert("Sweetheart Monitor will not work properly if you don't give yourself a USER name!");
    }
    if(preferences.partnerName.value == "NotSet") {
      alert("Sweetheart Monitor will not work properly if you don't give your PARTNER a name!");    
    }
  }
}

/**
Upon the event of the preferences window being shown,
save the current preference values before any changes
 can be made.
**/
function grabOldSettings() {
  uploadServerTmp = preferences.uploadServer.value;
  uploadUsernameTmp = preferences.uploadUsername.value;
  uploadPasswordTmp = preferences.uploadPassword.value;
  downloadServerTmp = preferences.downloadServer.value;  
  downloadUsernameTmp = preferences.downloadUsername.value;
  downloadPasswordTmp = preferences.downloadPassword.value;
  usernameTmp = preferences.userName.value;
  partnernameTmp = preferences.partnerName.value;
  userMoodFileLocationTmp = preferences.userMoodFileLocation.value;
  partnerMoodFileLocationTmp = preferences.partnerMoodFileLocation.value;
}

/**
Sets the Timer interval, validates preferences.  If the
preferences are valid, then all preference values are
saved.  If the preferences are not valid, then the widget
is put into testing mode and default values are used and
the preferences dialog is shown.
**/
function readSettings() {
  // Validate settings
  checkSettings();
  
  // Set timer interval
  Timer.interval = preferences.timerInterval.value;  

  // If preferences status is good, then update all variables
  if(preferences.status.value == "good") {
    // Check for name changes and update proper components
    if(preferences.userName.value != usernameTmp) {    
      putMood();      
    } else if(preferences.partnerName.value != partnernameTmp) {     
      preferences.partnerMoodFileLocation.value = system.widgetDataFolder + "/"
                                                + preferences.partnerName.value + "List.xml";
      testDownloadFile();
    }    
  } else {
  // If status bad, then put the program in test mode

    // Switch to testing mode
    switchTesting(true);

    // Prompt for correction
    showWidgetPreferences();
  }
 
  // Initialize user and partner names
  if(preferences.status.value == "good" && !testing) {
    Upper_Name.data = preferences.partnerName.value;
  } 
  Lower_Name.data = preferences.userName.value;

  // Make status good, since all values are good or set to default values
  preferences.status.value = "good";
}

/**
 Validates preferences by checking to see if any
 required value is left blank, and if either the upload
 or download server has been changed from the saved
 values, then they are tested.  If any preference value is 
 invalid, then an error message is shown and the 
 preferences status is set to bad; otherwise, the status is
 set to good.
**/
function checkSettings() {
  var count = 0;
  var errorMsg = "(ERRORS)\n";
  var result;
  
  // To avoid processor conflicts stop Timer
  if(!testing) {  
    Timer.ticking = false;
  }
  
  // Check for blank fields
  if(preferences.userName.value == "") {
    preferences.userName.value = usernameTmp;
    errorMsg += "\nYou left the 'preferences.userName.value' field blank!\n";   
    count++;  
  }  
  if(preferences.partnerName.value == "") {
    preferences.partnerName.value = partnernameTmp;  
    errorMsg += "\nYou left your partner's 'preferences.userName.value' field blank!\n";     
    count++;   
  }    
  if(preferences.uploadServer.value == "") {
    preferences.uploadServer.value = uploadServerTmp;
    errorMsg += "\nYou left the 'upload server' field blank!\n";  
    count++;            
  }      
  if(preferences.downloadServer.value == "") {
    preferences.downloadSever.value = downloadServerTmp;
    errorMsg += "\nYou left the 'download server' field blank!\n";  
    count++;            
  }
  if(preferences.userMoodFileLocation.value == "") {
    preferences.userMoodFileLocation.value = userMoodFileLocationTmp;
    errorMsg += "\nNote: You left the location of your mood file blank! Using userDefaultList.xml\n";              
  }     
  if(preferences.partnerMoodFileLocation.value == "") {
    preferences.partnerMoodFileLocation.value = partnerMoodFileLocationTmp;             
  }  
  
  // Check for mood file location changes
  if(preferences.userMoodFileLocation.value != userMoodFileLocationTmp) {
    if(!filesystem.itemExists(preferences.userMoodFileLocation.value)) {
      preferences.userMoodFileLocation.value = userMoodFileLocationTmp;
      errorMsg += "\nThe user mood file location is not valid!\n";
      count++;
    }
  }
  if(preferences.partnerMoodFileLocation.value != partnerMoodFileLocationTmp) {
    testDownloadFile();
  }
  
  // Check for server changes
  if(preferences.downloadServer.value != downloadServerTmp ||
     preferences.downloadUsername.value != downloadUsernameTmp ||
     preferences.downloadPassword.value != downloadPasswordTmp) {
    showMessage("Validating..");
    alert("The download server information must be validated."
        + "\n\nThis may take a few seconds..");
    preferences.downloadServer.value = checkServerSlash(preferences.downloadServer.value);        
    result = testDownloadServer();
    hideMessage();
    if(result) {
      errorMsg += "\nThe download server you specified doesn't work!\n";
      // Reset values
      preferences.downloadServer.value = downloadServerTmp;
      preferences.downloadUsername.value = downloadUsernameTmp;
      preferences.downloadPassword.value = downloadPasswordTmp;       
      count++;            
    } else {
      alert("Download Server was updated successfully.");
    }
  }
  if(preferences.uploadServer.value != uploadServerTmp ||
     preferences.uploadUsername.value != uploadUsernameTmp ||
     preferences.uploadPassword.value != uploadPasswordTmp) {
    showMessage("Validating..");
    alert("The upload server information must be validated."
        + "\n\nThis may take a few seconds..");
    preferences.downloadServer.value = checkServerSlash(preferences.downloadServer.value);         
    result = testUploadServer();
    hideMessage();
    if(result) {
      errorMsg += "\nThe upload server you specified doesn't work!\n";
      // Reset values
      preferences.uploadServer.value = uploadServerTmp;
      preferences.uploadUsername.value = uploadUsernameTmp;
      preferences.uploadPassword.value = uploadPasswordTmp;       
      count++;            
    } else {
      alert("Upload Server was updated successfully.");
    }
  }  

  // Determine error count and set the status
  if(count > 0) {
    errorMsg += "\n\nUsing old settings..";
    alert(errorMsg); // Display error messages
    preferences.status.value = "bad";    
  } else {
    preferences.status.value = "good";
  }
  
  // If not testing, turn the Timer back on
  if(!testing) {
    Timer.ticking = true;
  }
}

/**
Checks to ensure the last character is a  forward slash
**/
function checkServerSlash(name) {
  var lastChar = name.charAt(name.length - 1);
  if(lastChar != "/") {
    return name + "/";
  } else {
    return name;
  }
}

/**
Verifies the upload server is valid.
**/
function testUploadServer() {
  // Get response from server
  var result = runCommand("curl -I -s -S " + preferences.uploadServer.value + " -u "
                        + preferences.uploadUsername.value 
                        + ":" + preferences.uploadPassword.value);
    
  // Grab first word,
  result = result.split(" ");
  result = result[0];
  
  // Evaluate response
  if(runCommand("echo " + result + " | grep 'curl:'").length == 0) {
    return false;
  } else {
    return true;
  }
}

/**
Verifies the download server is valid.
**/
function testDownloadServer() {
  // Get response from server
  var result = runCommand("curl -I -s -S " + preferences.downloadServer.value + " -u "
                    + preferences.downloadUsername.value 
                    + ":" + preferences.downloadPassword.value);
                    
  // Grab first word,
  result = result.split(" ");
  result = result[0];
            
  // Evaluate response
  if(runCommand("echo " + result + " | grep curl: ").length == 0) {
    return false;
  } else {
    return true;
  }
}

/**
Verifies that the partner's mood file exists on the download server
**/
function testDownloadFile() {
  // Output test file
  runCommandInBg("curl -s -o testFile " + preferences.downloadServer.value + preferences.partnerName.value + "List.xml", "downloadFile");
}

/**
Switches the testing flag. If enabling, flips the 
drop arrow, stops the Timer, and opens up the wings.  
If disabling, verifies preferences are valid, flips 
the drop arrow, starts the timer, and prompts the widget
to get the latest parnter mood.
**/
function switchTesting(flag) {
  // Set flag
  testing = flag;  
  preferences.testing.value = testing;

  // Change popup menu
  createPopupMenu(); 
  
  // Enable testing
  if(testing) {  
    // Opens wings
    if(!isOpen) {
      open();
    }
    // Update components
    Upper_Name.data = "(testing)";    
    Lower_Drop_Arrow.visible = 0;
    Drop_Arrow.visible = 1;
    Refresh.visible = 0;
    Timer.ticking = false;    
    
    // Shows message
    showTimedMessage("Testing On", 100);
  } else {
  // Disable testing
    grabOldSettings();
    checkSettings();
    if(preferences.status.value == "good") {
      // Update components
      Upper_Name.data = preferences.partnerName.value;  
      Drop_Arrow.visible = 0;
      Lower_Drop_Arrow.visible = 1;
      if(isOpen) {
        Refresh.visible = 1;
      }        
      Timer.ticking = true;
      
      // Show message
      showTimedMessage("Testing Off", 100);
      
      // Download latest partner's mood
      testDownloadFile();
    }
  }
} 

/**
Handles all background commands.  Handles the upload
command and the download command.  
**/
function handleCommand() { 
  // Grab the bgCommand that just finished
  var tag = system.event.data;  
  
  // If downloading partner's mood file
  if(tag == "updatePartnerList") {
    // Update components
    readPartnerXML();
    print("(handleCommand) Updated Partner List");
  } else if(tag == "downloadFile") {
  // Else if downloadFile, verify the file exists on the server
    
    // If the file exists
    if(filesystem.itemExists("testFile")) {
      // If the file contains the word heartColor, consider the file valid
      if(runCommand("grep 'heartColor' testFile").length > 0) {
        preferences.partnerMoodFileLocation.value = system.widgetDataFolder + "/"
                                                  + preferences.partnerName.value + "List.xml";
        getMood();
      } else {
        preferences.partnerMoodFileLocation.value = "userDefaultList.xml";
      }     
    }
  } else if(tag == "updateUserList") {
  // Else if uploading user's mood file
      
    // Hide uplading message
    hideMessage();
    
    // If not testing, start timer that was stopped during upload to avoid conflicts
    if(!testing) {
      Timer.ticking = true;
    }
    print("(handleCommand) Updated User List");
  }
}

/**
Displays the vOffset and hOffset values for an object
that is being dragged within the bounds of the widget.
**/
function handleMouseMove(object) {
  object.hOffset = system.event.hOffset;
  object.vOffset = system.event.vOffset;
  print("(" + system.event.hOffset + ", " + system.event.vOffset + ")");
}

/**
If in testing mode, reads all the moods from both the user
and the partner's file and creates a popup menu with these
names.  If not in testing mode, reads all the mood from the
user's file and creates a popup menu with these names.
**/
function createPopupMenu() { 
  var moodList;
  var node;
  var count = 0;
  moodArray = new Array();      
  
  // Create user title if testing
  if(testing) {
    moodArray[0] = new MenuItem();
    moodArray[0].title = "*** " + preferences.userName.value.toUpperCase() + " ***";
    moodArray[0].enabled = false;
    count += 1;    
  } 
  
  // If file doesn't exist
  if(!filesystem.itemExists(preferences.userMoodFileLocation.value)) {
    preferences.userMoodFileLocation.value = "userDefaultList.xml";
  }
  
  // Grab the user mood NodeList 
  userXML = XMLDOM.parse(filesystem.readFile(preferences.userMoodFileLocation.value));  
  moodList = userXML.evaluate("list/mood");  
  
  // Read all moods from the user's mood-file and updates moodArray
  for(i=0; i < moodList.length; i++) {
    if(testing) {
      count += i;
    } else {
      count = i;
    }
   
    moodArray[count] = new MenuItem();
    node = moodList.item(i);
    moodArray[count].title = node.getAttribute("name");
    if(testing) {
      moodArray[count].onSelect = "Mood_TextArea.data = '" + moodArray[count].title 
                                + "'; changeColors('user');";   
    } else {
      moodArray[count].onSelect = "updateXML('" + moodArray[count].title + "');";
    }
  }
 
  // If testing, combine the both the user's and partners mood lists
  if(testing) {
    // Create partner title
    count++;
    moodArray[count] = new MenuItem();
    moodArray[count].title = "*** " + preferences.partnerName.value.toUpperCase() + " ***";
    moodArray[count].enabled = false;
    count++;
    
    // Ensure file does not exist
    if(!filesystem.itemExists(preferences.partnerMoodFileLocation.value)) {
      preferences.partnerMoodFileLocation.value = "userDefaultList.xml";
    }
    
    // Grab the partner mood NodeList
    partnerXML = XMLDOM.parse(filesystem.readFile(preferences.partnerMoodFileLocation.value)); 
    moodList = partnerXML.evaluate("list/mood");
       
    // Read all moods from the partner's mood-file
    for(i=0; i < moodList.length; i++) {
      count += i;
      moodArray[count] = new MenuItem();
      node = moodList.item(i);
      moodArray[count].title = node.getAttribute("name"); 
      moodArray[count].onSelect = "Mood_TextArea.data = '" + moodArray[count].title
                                + "';changeColors('partner');";   
    }  
  }
}

/**
Displays the popup menu.
**/
function popMenu() {
  popupMenu(moodArray, 123, 160);  
}

/**
If in testing mode, read the value in the upper textArea
and change the upper textBox, Heart, and Wings' color. 
If not in testing mode, then if person is user, read the
value in the lower textArea and then change
the lower textBox color; else if person is partner, read
the value in the upper textArea and then change the upper
textBox, Heart, and Wings' color.
**/
function changeColors(person) {
  var node;
  
  // If testing, change the upper components
  if(testing) {
    // Grap proper node
    if(person == "user") {
      node = userXML.evaluate("list/mood[@name='" + Mood_TextArea.data + "']").item(0);      
    } else {
      node = partnerXML.evaluate("list/mood[@name='" + Mood_TextArea.data + "']").item(0); 
    }
    
    // Change upper components
    Heart.hslAdjustment = node.getAttribute("heartColor");
    Left_Wing.hslAdjustment = node.getAttribute("wingColor");
    Right_Wing.hslAdjustment = node.getAttribute("wingColor");
    Text_Box.hslAdjustment = node.getAttribute("heartColor");
    Tail.hslAdjustment = node.getAttribute("heartColor");      
  } else {
  // If not testing, change the proper components  
    if(person == "user") {
      // Change lower components
      node = userXML.evaluate("list/mood[@selected ='true']").item(0);
      Lower_Text_Box.hslAdjustment = node.getAttribute("heartColor");
      Lower_Tail.hslAdjustment = node.getAttribute("heartColor");     
    } else {
      // Change upper components
      node = partnerXML.evaluate("list/mood[@selected ='true']").item(0);  
      Heart.hslAdjustment = node.getAttribute("heartColor");
      Left_Wing.hslAdjustment = node.getAttribute("wingColor");
      Right_Wing.hslAdjustment = node.getAttribute("wingColor");
      Text_Box.hslAdjustment = node.getAttribute("heartColor");
      Tail.hslAdjustment = node.getAttribute("heartColor");    
    }
  }
}

/**
Determine the selected mood from the partner's file and
change the lower textArea to have this value.  Then prompt
the widget to change the appropriate colors.
**/
function readPartnerXML() {
  // If the file doesn't exist; an integrity check
  if(filesystem.itemExists(preferences.partnerMoodFileLocation.value)) {
    // Grab mood selected
    partnerXML = XMLDOM.parse(filesystem.readFile(preferences.partnerMoodFileLocation.value)); 
    node = partnerXML.evaluate("list/mood[@selected='true']").item(0);
    
    // Update the components
    Mood_TextArea.data = node.getAttribute("name");
    changeColors("partner");
  }
}

/**
Determine the selected mood from the user's file and
change the upper textArea to have this value.  Then prompt
the widget to change the appropriate colors.
**/
function readUserXML() {
  // If the file doesn't exist; an integrity check
  if(filesystem.itemExists(preferences.userMoodFileLocation.value)) {
    // Grab mood selected
    userXML = XMLDOM.parse(filesystem.readFile(preferences.userMoodFileLocation.value));
    var node = userXML.evaluate("list/mood[@selected='true']").item(0);
    // Update the components
    Lower_Mood_TextArea.data = node.getAttribute("name");
    changeColors("user");
  }
}

/**
Un-select the old user mood that was marked selected and
select the new user mood to be selected in the user's XML
file.  Then prompt the widget to upload the updated user
XML file.
**/
function updateXML(mood) {
  var node;
  
  // Grab old node and umark
  node = userXML.evaluate("list/mood[@selected='true']").item(0);
  node.setAttribute("selected", "false");
  
  // Grab new node and mark
  node = userXML.evaluate("list/mood[@name='" + mood + "']").item(0);
  node.setAttribute("selected", "true");
  
  // Write file
  filesystem.writeFile(preferences.userMoodFileLocation.value, userXML.toXML());

  // Update components
  readUserXML();

  // Upload new mood file  
  putMood();
}

/**
Upload the user's XML file.
**/
function putMood() {
  // If the file exists; an integrity check  
  if(filesystem.itemExists(preferences.userMoodFileLocation.value)) {
    // Show message  
    showMessage("Uploading..");
    updateNow(); // force widget to paint message

    // Stop timer to ensure no conflicts    
    Timer.ticking = false;
    
    // If server working, upload user's mood file
    runCommandInBg("curl -s -T \"" + preferences.userMoodFileLocation.value + "\" -u "
                  + preferences.uploadUsername.value + ":" + preferences.uploadPassword.value + " "
                  + preferences.uploadServer.value + preferences.userName.value + "List.xml", "updateUserList");                   
  } else {
    // Set the location to the default one
    preferences.userMoodFileLocation.value = "userDefaultList.xml";
  }
}

/**
Download the partner's XML file.
**/
function getMood() {  
  // If server working, download partner's mood
  runCommandInBg("curl -s -o '" + preferences.partnerMoodFileLocation.value + "' -u " 
               + preferences.downloadUsername.value + ":" + preferences.downloadPassword.value + " "
               + preferences.downloadServer.value + preferences.partnerName.value + "List.xml", "updatePartnerList");
}

/**
Enable testing mode, create all the components necessary
for the Mood Manager, hide the mainWindow, and then
show the Mood Manager.
**/
function launchMoodManager() {
  // Stop timer
  Timer.ticking = false;
  
  // Make default path the default setting
  Default.src = "Resources/Default_Full.png";
  
  // If file doesn't exist
  if(!filesystem.itemExists(preferences.partnerMoodFileLocation.value)) {
    preferences.partnerMoodFileLocation.value = "userDefaultList.xml";
  }
  
  // Grab moods
  userXML = XMLDOM.parse(filesystem.readFile(preferences.userMoodFileLocation.value));
  var nodeList = userXML.evaluate("list/mood");  
  
  // Initialize
  moodsFrame = new Frame();
  textAreas = new Array();
  scroll = new ScrollBar();
  
  // Setup scrollbar
  scroll.height = 92;
  scroll.autoHide = false;
  scroll.vOffset = 82;
  scroll.hOffset = 15;
  scroll.window = moodManager;
    
  // Setup frame
  moodsFrame.vScrollBar = scroll;
  moodsFrame.height = 92;
  moodsFrame.zOrder = 1;
  moodsFrame.vOffset = 82;
  moodsFrame.hOffset = 15;
  moodsFrame.window = moodManager;

  // Insert mood entries
  var node;
  for(i = 0; i < nodeList.length; i++) {
    node = nodeList.item(i);    
    textAreas[i] = new Array();
    // Mood column
    textAreas[i][0] = new TextArea();
    textAreas[i][0].bgColor = "#D8F1FD";
    textAreas[i][0].bgOpacity = 200;
    textAreas[i][0].opacity = 255;
    textAreas[i][0].color = "#000000";
    textAreas[i][0].editable = true;
    textAreas[i][0].columns = 6;
    textAreas[i][0].lines = 1;
    textAreas[i][0].vOffset = (i * 15) + 3;
    textAreas[i][0].hOffset = 15;
    textAreas[i][0].zOrder = 1;
    textAreas[i][0].data = node.getAttribute("name");
    textAreas[i][0].onGainFocus = "hasFocus = " + i + ";"
                                + "textAreas[" + i + "][0].bgColor = '#FFFFFF';"
                                + "textAreas[" + i + "][1].bgColor = '#FFFFFF';"
                                + "textAreas[" + i + "][2].bgColor = '#FFFFFF';";
    textAreas[i][0].onLoseFocus = "(textAreas[" + i + "][0].editable == true) ?"
                                + "(textAreas[" + i + "][0].bgColor = '#D8F1FD'):print(' ');"
                                + "textAreas[" + i + "][1].bgColor = '#FDEFE2';"
                                + "textAreas[" + i + "][2].bgColor = '#FDEFE2';";                                
    moodsFrame.addSubview(textAreas[i][0]);
    
    // Heart column
    textAreas[i][1] = new TextArea();
    textAreas[i][1].bgColor = "#FDEFE2";
    textAreas[i][1].bgOpacity = 200;
    textAreas[i][1].opacity = 255;
    textAreas[i][1].color = "#000000";
    textAreas[i][1].editable = false;
    textAreas[i][1].columns = 11;
    textAreas[i][1].lines = 1;
    textAreas[i][1].vOffset = (i * 15) + 3;
    textAreas[i][1].hOffset = 85;
    textAreas[i][1].zOrder = 1;
    textAreas[i][1].data = "(" + node.getAttribute("heartColor") + ")";                          
    moodsFrame.addSubview(textAreas[i][1]);
    
    // Wings column
    textAreas[i][2] = new TextArea();
    textAreas[i][2].bgColor = "#FDEFE2";
    textAreas[i][2].bgOpacity = 200;
    textAreas[i][2].opacity = 255;
    textAreas[i][2].color = "#000000";
    textAreas[i][2].editable = false;
    textAreas[i][2].columns = 11;
    textAreas[i][2].lines = 1;
    textAreas[i][2].vOffset = (i * 15) + 3;
    textAreas[i][2].hOffset = 189;
    textAreas[i][2].zOrder = 1;
    textAreas[i][2].data = "(" + node.getAttribute("wingColor") + ")";  
    moodsFrame.addSubview(textAreas[i][2]);

    // Heart
    textAreas[i][1].onMouseUp = "newMoodName = textAreas["
                              + i + "][0].data; showMoodColorChange(textAreas[" 
                              + i + "][1].data.slice(1, textAreas[" 
                              + i  + "][1].data.length - 1) , textAreas[" 
                              + i + "][2].data.slice(1, textAreas[" 
                              + i + "][2].data.length - 1) , 'heart'); textAreas[" 
                              + i + "][0].focus(); selectedT = textAreas[" 
                              + i + "][1];";
    // Wings
    textAreas[i][2].onMouseUp = "newMoodName = textAreas["
                              + i + "][0].data; showMoodColorChange(textAreas[" 
                              + i + "][1].data.slice(1, textAreas[" 
                              + i  + "][1].data.length - 1) , textAreas[" 
                              + i + "][2].data.slice(1, textAreas[" 
                              + i + "][2].data.length - 1) , 'wings'); textAreas[" 
                              + i + "][0].focus(); selectedT = textAreas[" 
                              + i + "][2];";                        
  }
  
  mainWindow.visible = 0;
  // Make sure mood is open
  if(!isOpen) {
    animateWings();
  }
  
  // Select first mood
  textAreas[0][0].focus();
  
  // Center moodManager
  moodManager.hOffset = (screen.availWidth / 2) - (moodManager.width / 2);
  moodManager.vOffset = (screen.availHeight / 2) - (moodManager.height / 2);  
  moodManager.visible = 1;
} 

/**
Hide the moodManager and then show the mainWindow.
**/
function moodManagerClosed() {
  moodManager.visible = 0;
  selectedT = undefined;
  mainWindow.visible = 1;  
  if(!testing) {
    Timer.ticking = true;
  }
}

/**
Add a new row to the moods in moodManager, and the 
put the focus on the new mood's name.
**/
function moodManagerAdd() {
    var arrayLength = textAreas.length;

    textAreas[arrayLength] = new Array();
    // Mood column
    textAreas[arrayLength][0] = new TextArea();
    textAreas[arrayLength][0].bgColor = "#D8F1FD";
    textAreas[arrayLength][0].bgOpacity = 200;
    textAreas[arrayLength][0].opacity = 255;
    textAreas[arrayLength][0].color = "#000000";
    textAreas[arrayLength][0].editable = true;
    textAreas[arrayLength][0].columns = 6;
    textAreas[arrayLength][0].lines = 1;
    textAreas[arrayLength][0].vOffset = (arrayLength * 15) + 3;
    textAreas[arrayLength][0].hOffset = 15;
    textAreas[arrayLength][0].zOrder = 1;
    textAreas[arrayLength][0].data = "New";
    textAreas[arrayLength][0].onGainFocus = "hasFocus = " + arrayLength + ";"
                                + "textAreas[" + arrayLength + "][0].bgColor = '#FFFFFF';"
                                + "textAreas[" + arrayLength + "][1].bgColor = '#FFFFFF';"
                                + "textAreas[" + arrayLength + "][2].bgColor = '#FFFFFF';";
    textAreas[arrayLength][0].onLoseFocus = "(textAreas[" + arrayLength + "][0].editable == true) ?"
                                + "(textAreas[" + arrayLength + "][0].bgColor = '#D8F1FD'):print(' ');"
                                + "textAreas[" + arrayLength + "][1].bgColor = '#FDEFE2';"
                                + "textAreas[" + arrayLength + "][2].bgColor = '#FDEFE2';";     
    moodsFrame.addSubview(textAreas[arrayLength][0]);
    
    // Heart column
    textAreas[arrayLength][1] = new TextArea();
    textAreas[arrayLength][1].bgColor = "#FDEFE2";
    textAreas[arrayLength][1].bgOpacity = 200;
    textAreas[arrayLength][1].opacity = 255;
    textAreas[arrayLength][1].color = "#000000";
    textAreas[arrayLength][1].editable = false;
    textAreas[arrayLength][1].columns = 11;
    textAreas[arrayLength][1].lines = 1;
    textAreas[arrayLength][1].vOffset = (arrayLength * 15) + 3;
    textAreas[arrayLength][1].hOffset = 85;
    textAreas[arrayLength][1].zOrder = 1;
    textAreas[arrayLength][1].data = "(0, 0, 0)";                          
    moodsFrame.addSubview(textAreas[arrayLength][1]);
    
    // Wings column
    textAreas[arrayLength][2] = new TextArea();
    textAreas[arrayLength][2].bgColor = "#FDEFE2";
    textAreas[arrayLength][2].bgOpacity = 200;
    textAreas[arrayLength][2].opacity = 255;
    textAreas[arrayLength][2].color = "#000000";
    textAreas[arrayLength][2].editable = false;
    textAreas[arrayLength][2].columns = 11;
    textAreas[arrayLength][2].lines = 1;
    textAreas[arrayLength][2].vOffset = (arrayLength * 15) + 3;
    textAreas[arrayLength][2].hOffset = 189;
    textAreas[arrayLength][2].zOrder = 1;
    textAreas[arrayLength][2].data = "(0, 0, 0)";  
    moodsFrame.addSubview(textAreas[arrayLength][2]);

    // Heart
    textAreas[arrayLength][1].onMouseUp = "newMoodName = textAreas["
                              + arrayLength + "][0].data; showMoodColorChange(textAreas[" 
                              + arrayLength + "][1].data.slice(1, textAreas[" 
                              + arrayLength  + "][1].data.length - 1) , textAreas[" 
                              + arrayLength + "][2].data.slice(1, textAreas[" 
                              + arrayLength + "][2].data.length - 1) , 'heart'); textAreas[" 
                              + arrayLength + "][0].focus(); selectedT = textAreas[" 
                              + arrayLength + "][1]";
    // Wings
    textAreas[arrayLength][2].onMouseUp = "newMoodName = textAreas["
                              + arrayLength + "][0].data; showMoodColorChange(textAreas[" 
                              + arrayLength + "][1].data.slice(1, textAreas[" 
                              + arrayLength  + "][1].data.length - 1) , textAreas[" 
                              + arrayLength + "][2].data.slice(1, textAreas[" 
                              + arrayLength + "][2].data.length - 1) , 'wings'); textAreas[" 
                              + arrayLength + "][0].focus(); selectedT = textAreas[" 
                              + arrayLength + "][2];";          

    // Focus the new mood    
    textAreas[arrayLength][0].focus();
    hasFocus = arrayLength;
    textAreas[arrayLength][0].select(0, -1);
    scroll.setRange(0, scroll.max);
    scroll.value = scroll.max;
}

/**
Make the mood field uneditable and the colors unclickable.
And change the row's color to red.
**/
function moodManagerRemove() {
  textAreas[hasFocus][0].bgColor = "#E2090F";
  textAreas[hasFocus][0].editable = false;
  textAreas[hasFocus][1].bgColor = "#E2090F";
  textAreas[hasFocus][1].onMouseUp = "";
  textAreas[hasFocus][2].bgColor = "#E2090F";
  textAreas[hasFocus][2].onMouseUp = "";
}

/**
Handles default locaiton save switch box
**/
function switchDefault() {
  if(Default.src == "Resources/Default_Empty.png") {
    Default.src = "Resources/Default_Full.png";
  } else {
    Default.src = "Resources/Default_Empty.png";
  }
}

/**
Create a new user XML file, adding new moods and
removing any that were marked red.
**/
function moodManagerSave() {
  var doc = XMLDOM.createDocument();
  var list = doc.createElement("list");
  doc.appendChild(list);
  
  var mood;
  var name;
  var heartColor;
  var wingColor;
  var selected;    
  
  for(i = 0; i < textAreas.length; i++) {
    if(textAreas[i][0].bgColor != "#E2090F") {
      // Element
      mood = doc.createElement("mood");
      
      // Name
      name = doc.createAttribute("name");
      name.value = textAreas[i][0].data;
      mood.setAttributeNode(name);
      
      // Heart Color
      heartColor = doc.createAttribute("heartColor");
      heartColor.value = textAreas[i][1].data.slice(1, textAreas[i][1].data.length - 1);
      mood.setAttributeNode(heartColor);
      
      // Wing Color
      wingColor = doc.createAttribute("wingColor");
      wingColor.value = textAreas[i][2].data.slice(1, textAreas[i][2].data.length - 1);
      mood.setAttributeNode(wingColor);
      
      // Selected
      selected = doc.createAttribute("selected");
      selected.value = "false";
      mood.setAttributeNode(selected);
      
      list.appendChild(mood);
    }
  }
  
  // Ensure one is marked as selected
  var oldSelected = userXML.evaluate("list/mood[@selected='true']").item(0);
  var node = doc.evaluate("list/mood[@name='" + oldSelected.getAttribute("name") + "']");
  if(node.length == 0) {
    node = doc.evaluate("list/mood").item(0);
    node.setAttribute("selected", "true");
  } else {
    node.item(0).setAttribute("selected", "true");
  }
  
  // Prompt for save location if needed
  if(Default.src == "Resources/Default_Empty.png") {
    var location = saveAs(".xml");
    if(location != null) {      
      preferences.userMoodFileLocation.value = location;
    } else {
      alert("You did not specify a location!"
          + "\n\nThe file will be saved here: \n"
          + system.widgetDataFolder + "/" + preferences.userName.value
          + "List.xml");
      preferences.userMoodFileLocation.value = system.widgetDataFolder + "/" + preferences.userName.value
                                             + "List.xml";
    }
  } else {
    preferences.userMoodFileLocation.value = system.widgetDataFolder + "/" + preferences.userName.value
                                          + "List.xml";
  }
  
  // Save file
  filesystem.writeFile(preferences.userMoodFileLocation.value, doc.toXML());
  
  // Update mood 
  testing = false;
  readUserXML();
  if(preferences.testing.value == "true") {
    testing = true;
  }
  createPopupMenu();
  
  // Start timer if not testing
  if(!testing) {
    Timer.ticking = true;
  }
  
  // Display window
  moodManager.visible = 0;
  selectedT = undefined;
  mainWindow.visible = 1;
  showTimedMessage("Saved", 600);   
  putMood();
}

/**
Create all the components necessary for the Form, hide
the moodManager and show the mainWindow, and show
the Form.  If user clicks on Preview, then show the color
changes and prompt the user to accept or reject them.  If
the user clicks Yes, then return the color changes to the
moodManager.   If the user clicks No, then return to the
Form again.  If the user clicks on Close, then hide the 
mainWindow, close the Form, return the initial value, 
and display the moodManager.
**/
function showMoodColorChange(heartC, wingsC, object) {
  // Center moodManager
  colorChanger.hOffset = (screen.availWidth / 2) - (colorChanger.width / 2);
  colorChanger.vOffset = (screen.availHeight / 2) - (colorChanger.height / 2);
  oldX = mainWindow.hOffset;
  oldY = mainWindow.vOffset;
  mainWindow.hOffset = colorChanger.hOffset - mainWindow.width + 70;
  mainWindow.vOffset = (screen.availHeight / 2) - (mainWindow.height / 2) - 80;
  
  // change windows
  moodManager.visible = 0;
  mainWindow.visible = 1;
  colorChanger.visible = 1;
  Heart.onMouseEnter = undefined;
  
  // Grab saved color
  oldHeartC = Heart.hslAdjustment;
  oldWingC = Left_Wing.hslAdjustment;
  
  // Set mood name for display
  oldMoodName = Mood_TextArea.data;
  Mood_TextArea.data = newMoodName;
  
  // Grab incoming colors
  var startV;
  if(object == "wings") {
    startV = wingsC.split(",");
  } else {    
    startV = heartC.split(",");
  }
  Right_Wing.hslAdjustment = wingsC;
  Left_Wing.hslAdjustment = wingsC;
  Heart.hslAdjustment = heartC;
  Tail.hslAdjustment = heartC;
  Text_Box.hslAdjustment = heartC;

  function changeHue(value) {
    var change = value + ", " + sliders[1].getValue() + ", " + sliders[2].getValue();
    if(object == "heart") {
      Heart.hslAdjustment = change;
    } else {
      Left_Wing.hslAdjustment = change;
      Right_Wing.hslAdjustment = change;
    }
  }  
  
  function changeSat(value) {
    var change = sliders[0].getValue() + ", " + value + ", " + sliders[2].getValue();
    if(object == "heart") {
      Heart.hslAdjustment = change;
    } else {
      Left_Wing.hslAdjustment = change;
      Right_Wing.hslAdjustment = change;
    }
  }  
  
  function changeLight(value) {
    var change = sliders[0].getValue() + ", " + sliders[1].getValue() + ", " + value;
    if(object == "heart") {
      Heart.hslAdjustment = change;
    } else {
      Left_Wing.hslAdjustment = change;
      Right_Wing.hslAdjustment = change;
    }    
  }
  
  // Set up sliders
  sliders[0] = new Slider(25, 70, colorChanger);
  sliders[0].setWidth(300);
  sliders[0].setOnMouseMove(changeHue);
  sliders[0].setRange("-180, 180");
  sliders[0].setTicks(5);
  sliders[0].valueTicks();
  sliders[0].setLabelSize(12);
  sliders[0].setValue(parseInt(startV[0]));
  
  sliders[1] = new Slider(25, 110, colorChanger);
  sliders[1].setWidth(300);
  sliders[1].setOnMouseMove(changeSat);
  sliders[1].setRange("-100, 100");
  sliders[1].setTicks(9);
  sliders[1].setLabels("dull, normal, vibrant");
  sliders[1].setLabelSize(12);
  sliders[1].setValue(parseInt(startV[1]));  
  
  sliders[2] = new Slider(25, 150, colorChanger);
  sliders[2].setWidth(300);
  sliders[2].setOnMouseMove(changeLight);
  sliders[2].setRange("-80, 80");
  sliders[2].setTicks(5);
  sliders[2].setLabels("dark, normal, light");
  sliders[2].setLabelSize(12); 
  sliders[2].setValue(parseInt(startV[2]));  
}

/**
Handles a color changer save.
**/
function colorChangerSave() {  
  selectedT.data = "(" + sliders[0].getValue() + ", "
                 + sliders[1].getValue() + ", "
                 + sliders[2].getValue() + ")";
  
  colorChangerCancel();
}

/**
Handles a color changer cancel
**/
function colorChangerCancel() {
  Heart.hslAdjustment = oldHeartC;
  Left_Wing.hslAdjustment = oldWingC;
  Right_Wing.hslAdjustment = oldWingC;
  Tail.hslAdjustment = oldHeartC;
  Text_Box.hslAdjustment = oldHeartC;
  
  mainWindow.visible = 0;
  mainWindow.hOffset = oldX;
  mainWindow.vOffset = oldY;
  colorChanger.visible = 0;
  moodManager.visible = 1;  
  
  Mood_TextArea.data = oldMoodName;
  
  Heart.onMouseEnter = displayHud;
}

/**
Converts the HEX value to RGB.
**/
function convertHEXtoRGB(hex) {
  var red;
  var green;
  var blue;
  
  // Strip # sign if present
  hex = (hex.charAt(0) == "#") ? hex.substring(1, 7) : hex;
  
  // Change to base 16
  red = parseInt(hex.substring(0,2),16);
  green = parseInt(hex.substring(2,4),16);
  blue = parseInt(hex.substring(4,6),16);
  
  // Return answer
  var rgb = new Array(3);
  rgb[0] = red;
  rgb[1] = green;
  rgb[2] = blue;
  return rgb;
}

/**
Converts a RGB value to HSL.
**/
function convertRGBtoHSL(red, green, blue) {
  var hue = 0.0;
  var minVal = Math.min(red, green, blue);
  var maxVal = Math.max(red, green, blue);  
  var lightness = maxVal / 255.0; // Set lightness
  var saturation = 0.0;

  // Set saturation
  if (maxVal > 0) {
    saturation = ( (maxVal - minVal) / maxVal);
  } else {
    saturation = 0;
  }

  if (minVal > 0) {
    red = (red / minVal)-1;
    green = (green / minVal)-1;
    blue = (blue / minVal)-1;
  }
	
  maxVal = Math.max(red, green, blue);

  // Set hue
  if ((red == green) && (green == blue)) {
		hue = 0.0;
  } else {  
		if (maxVal > 0) {
			red = red / maxVal;
			green = green / maxVal;
			blue = blue / maxVal;
		}

		maxVal = Math.max(red, green, blue); // grab max

		if (maxVal == red) {
			if (green > 0.0) {
				hue = 60 * (green / red);
			} else {
				hue = 360 + (-60 * (blue / red));
			}
		} else if (maxVal == green) {
			if (red > 0.0) {
				hue = 120 - ((red / green) * 60);
			} else {
				hue = 120 + ((blue / green) * 60);
			}
		}	else if (maxVal == blue) {
			if (green > 0.0) {
				hue = 240 - ((green / blue) * 60);
			} else {
				hue = 240 + ((red / blue) * 60);
			}
		}
	}
  
  // Adjust values
  hue = Math.round(hue);  
  saturation = Math.round((1 - saturation) * 360);
  lightness = Math.round((1 - lightness) * 360);  
  
  // Adjust from 0 to 360 to -180 to 180 range
  if(hue > 180) {
    hue = (hue - 180) - 180;
  }
  if(saturation > 180) {
    saturation = (saturation - 180) - 180;
  }
  if(lightness > 180) {
    lightness = (lightness - 180) - 180;
  }
  
  //alert("Hue: " + hue + "\nSat: " + saturation + "\nLight: " + lightness);
  
  // Return answer
  var hsl = new Array(3);
  hsl[0] = hue;
  hsl[1] = saturation;
  hsl[2] = lightness;
  return hsl;
}

/**
Display the Hud buttons.
**/
function displayHud() {
  var delay = 120;

  var hudExit = new FadeAnimation(Hud_Exit, 180, delay, animator.kEaseOut);
  var hudOpen = new FadeAnimation(Hud_Open, 180, delay, animator.kEaseOut);
  var hudPreferences = new FadeAnimation(Hud_Preferences, 250, delay, animator.kEaseOut);
  var hudMoodManager = new FadeAnimation(Hud_MoodManager, 220, delay, animator.kEaseOut);
  var hudTest = new FadeAnimation(Hud_Test, 255, delay, animator.kEaseOut);
  
  animator.runUntilDone(new Array(hudExit, hudOpen, hudPreferences, hudMoodManager, hudTest));
}

/**
Hide the Hud buttons.
**/
function hideHud() {
  var delay = 120;

  var hudExit = new FadeAnimation(Hud_Exit, 0, delay, animator.kEaseOut);
  var hudOpen = new FadeAnimation(Hud_Open, 0, delay, animator.kEaseOut);
  var hudPreferences = new FadeAnimation(Hud_Preferences, 0, delay, animator.kEaseOut);
  var hudMoodManager = new FadeAnimation(Hud_MoodManager, 0, delay, animator.kEaseOut);
  var hudTest = new FadeAnimation(Hud_Test, 0, delay, animator.kEaseOut);
  
  animator.runUntilDone(new Array(hudExit, hudOpen, hudPreferences, hudMoodManager, hudTest));
}

/**
Handles the opening and closing of the wings.
**/
function animateWings() {
  if(isOpen)
    close();
  else
    open();   
}

/**
Handles testing Hud switch
**/
function handleHudTest() {
  if(preferences.status.value == "good") {
    if(testing) {
      switchTesting(false);
    } else {
      switchTesting(true);
    }
  }
}

/**
Shows a static message and prompts for processAnimation.
**/
function showMessage(message) {
  Message_Center.visible = 1;
  Message_Center.data = message;
  processAnimation();
  
  // Disable hud
  Hud_Exit.visible = 0;
  Hud_Open.visible = 0;
  Hud_Preferences.visible = 0;
  Hud_MoodManager.visible = 0;
  Hud_Test.visible = 0;
}

/**
Shows a message for a specified amount of time.
**/
function showTimedMessage(message, delay) {
  Message_Center.visible = 1;
  Message_Center.opacity = 0;
  Message_Center.data = message;
  
  // Disable hud
  Hud_Exit.visible = 0;
  Hud_Open.visible = 0;
  Hud_Preferences.visible = 0;
  Hud_MoodManager.visible = 0;
  Hud_Test.visible = 0;

  // Show message
  var showMessage = new FadeAnimation(Message_Center, 255, 1000, animator.kEaseOut);
  animator.runUntilDone(showMessage);  
  
  // Pause
  var delayMessage = new FadeAnimation(Message_Center, 255, delay, animator.kEaseOut);
  animator.runUntilDone(delayMessage);
  
  // Reset Message Center
  Message_Center.visible = 0;
  Message_Center.opacity = 255;
  
  // Enable Hud
  Hud_Exit.visible = 1;
  Hud_Open.visible = 1;
  Hud_Preferences.visible = 1;
  Hud_MoodManager.visible = 1;
  Hud_Test.visible = 1;
}

/**
Hides a static message generated by showMessage() and 
kills the process animation.
**/
function hideMessage() {
  Message_Center.visible = 0;
  Processing.opacity = 0;  
  processRotation.kill();
  
  // Enable hud
  Hud_Exit.visible = 1;
  Hud_Open.visible = 1;
  Hud_Preferences.visible = 1;
  Hud_MoodManager.visible = 1;
  Hud_Test.visible = 1;
}

/**
Opens up the wings.
**/
function open() {     
  isOpen = true; // Sets flag for animateWings function
  Heart.src = "Resources/Heart_No_Border.png"; // Change Heart image for proper rendering
  
  // Handles Right Wing animation
  var r_rotate = new RotateAnimation(Right_Wing, 0, 700, animator.kEaseIn);
  var r_shift = new MoveAnimation(Right_Wing, (Right_Wing.hOffset - 10), (Right_Wing.vOffset + 3), 600);
  
  // Handles Left Wing animation
  var l_rotate = new RotateAnimation(Left_Wing, 0, 700, animator.kEaseIn);
  var l_shift = new MoveAnimation(Left_Wing, (Left_Wing.hOffset + 14), (Left_Wing.vOffset + 11), 600);
  
  // Handles Upper_Tail animation
  var t_drop = new MoveAnimation(Tail, Tail.hOffset, (Tail.vOffset + 58), 675);  
  animator.runUntilDone(new Array(r_rotate, r_shift, l_rotate, l_shift, t_drop)); // Runs syncronous animation
  
  // Upon animation completion, display necessary components for upper mood selection
  Text_Box.opacity = 500;
  Mood_TextArea.opacity = 255;
  Drop_Arrow.opacity = 500;
  Upper_Name.opacity = 500;
  if(!testing) {
    Refresh.visible = 1;
  }
  
  // Handles Lower_Tail animation
  Lower_Tail.opacity = 500;  
  var lt_drop = new MoveAnimation(Lower_Tail, Lower_Tail.hOffset, (Lower_Tail.vOffset + 8), 100);
  animator.runUntilDone(lt_drop); // Runs syncronous animation
  
  // Upon animation completion, display necessary components for lower mood selection  
  Lower_Text_Box.opacity = 500;
  Lower_Mood_TextArea.opacity = 255;
  Lower_Drop_Arrow.opacity = 500;
  Lower_Name.opacity = 500;   
}

/**
Closes the wings.
**/
function close() {  
  isOpen = false; // Sets flag  
  
  // Handles rotation  animation for both Wings
  var r_rotate = new RotateAnimation(Right_Wing, 93, 600, animator.kEaseIn);
  var l_rotate = new RotateAnimation(Left_Wing, -94, 600, animator.kEaseIn);  
  animator.runUntilDone(new Array(r_rotate, l_rotate)); // Runs rotation synchronous animation
  
  // Resets lower mood selection components
  Lower_Tail.opacity = 0;    
  Lower_Tail.vOffset -= 8;
  
  // Upon Lower_Tail animation completion, remove upper mood selection components
  Lower_Name.opacity = 0;  
  Lower_Text_Box.opacity = 0;
  Lower_Mood_TextArea.opacity = 0;
  Lower_Drop_Arrow.opacity = 0;
  Upper_Name.opacity = 0;
  Text_Box.opacity = 0;
  Mood_TextArea.opacity = 0;
  Drop_Arrow.opacity = 0;
  Refresh.visible = 0;  
  
  // Handles move animation for both Wings and the Tail
  var r_shift = new MoveAnimation(Right_Wing, (Right_Wing.hOffset + 10), (Right_Wing.vOffset - 3), 200);
  var l_shift = new MoveAnimation(Left_Wing, (Left_Wing.hOffset - 14), (Left_Wing.vOffset - 11), 200);
  var t_raise = new MoveAnimation(Tail, Tail.hOffset, (Tail.vOffset - 57), 100);
  
  animator.runUntilDone(new Array(r_shift, l_shift, t_raise)); // Runs move synchronous animation

  Heart.src = "Resources/Heart.png"; // Change Heart image for proper rendering
}

/**
Displays the processing animation.
**/
function processAnimation() {  
  Processing.opacity = 300;
  processRotation = new RotateAnimation(Processing, (Processing.rotation + 5000), 11000, animator.kEaseNone);  
  animator.start(processRotation);
}

setup();
